﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;

namespace GetAreaTest
{
	public static class JsonExtension
	{
		public static bool IsNullOrEmpty(this JToken token)
		{
			return (token == null) ||
				(token.Type == JTokenType.Array && !token.HasValues) ||
				(token.Type == JTokenType.Object && !token.HasValues) ||
				(token.Type == JTokenType.String && token.ToString() == string.Empty) ||
				(token.Type == JTokenType.Null);
		}

		public static T GetValue<T>(this JToken token, T defaultValue = default(T))
		{
			if (typeof(string) == typeof(T))
				defaultValue = (T)(object)string.Empty;
			return token.IsNullOrEmpty() ? defaultValue : token.Value<T>();
		}
	}
}
